import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
import { renderColors } from '../common/utils.js';
var PieChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) || false,
                orient: ((_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.legend) === null || _d === void 0 ? void 0 : _d.orient) || 'horizontal',
                left: ((_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.legend) === null || _f === void 0 ? void 0 : _f.left) || 'auto',
                right: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.legend) === null || _h === void 0 ? void 0 : _h.right) || 'auto',
                top: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.legend) === null || _k === void 0 ? void 0 : _k.top) || 'auto',
                bottom: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.legend) === null || _m === void 0 ? void 0 : _m.bottom) || 'auto',
            },
            tooltip: {
                show: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.show) || false,
                trigger: ((_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.trigger) || 'axis',
                backgroundColor: ((_t = (_s = props.setup.chart) === null || _s === void 0 ? void 0 : _s.tooltip) === null || _t === void 0 ? void 0 : _t.backgroundColor) || '#000',
                borderRadius: ((_v = (_u = props.setup.chart) === null || _u === void 0 ? void 0 : _u.tooltip) === null || _v === void 0 ? void 0 : _v.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_y = (_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.tooltip) === null || _x === void 0 ? void 0 : _x.textStyle) === null || _y === void 0 ? void 0 : _y.fontSize) || 'normal',
                    color: ((_1 = (_0 = (_z = props.setup.chart) === null || _z === void 0 ? void 0 : _z.tooltip) === null || _0 === void 0 ? void 0 : _0.textStyle) === null || _1 === void 0 ? void 0 : _1.color) || '#fff',
                    fontWeight: 'normal',
                },
            },
            series: [
                {
                    type: 'pie',
                    radius: ['40%', '70%'],
                    avoidLabelOverlap: false,
                    padAngle: 5,
                    itemStyle: {
                        borderRadius: 10,
                        borderColor: '#fff',
                        borderWidth: 1,
                    },
                    label: {
                        show: false,
                        position: 'center',
                    },
                    emphasis: {
                        label: {
                            show: true,
                            fontSize: 20,
                            fontWeight: 'bold',
                        },
                    },
                    labelLine: {
                        show: false,
                    },
                    data: (_2 = props.chartData) === null || _2 === void 0 ? void 0 : _2.map(function (item) {
                        var _a, _b, _c, _d;
                        return ({
                            value: Number(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.y_axis) === null || _b === void 0 ? void 0 : _b.field]),
                            name: item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field],
                        });
                    }),
                    color: renderColors(((_3 = props.setup.chart) === null || _3 === void 0 ? void 0 : _3.item_styles) || [], (_4 = props.chartData) === null || _4 === void 0 ? void 0 : _4.length),
                },
            ],
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption(), style: { width: '100%', height: '100%' } });
};
export default PieChart;
